#!/bin/sh
#
# drop example database TST
###########################################

PATH=$IND/bin:$PATH
export PATH

set -x

# name of the database
SID=TST

run_dir=`dbmcli -d $SID -u dbm,dbm param_directget RUNDIRECTORY 2>&1`
rc=$?

if [ $rc != 0 ]
then
	echo "cannot get run directory"2>&1
else
	run_dir=`echo $run_dir | grep RUNDIRECTORY | sed -e 's/.*RUNDIRECTORY[^\/]*//'`
fi

# start remote communication server
x_server start >/dev/null 2>&1

# stop and drop probably existing demo database
dbmcli -d $SID -u dbm,dbm db_offline >/dev/null 2>&1
dbmcli -s -d $SID -u dbm,dbm db_drop >/dev/null 2>&1

if [ "$run_dir" != "" && -d $run_dir ]
then
	rm $run_dir/datasave 2>&1 > /dev/null
	rm $run_dir/autosave.* 2>&1 > /dev/null
fi


exit 0
